<?php

/**
 * ECSHOP 支付配送DEMO
 * ============================================================================
 * 版权所?(C) 2005-2007 康盛创想（北京）科技有限公司，并保留所有权利?
 * 网站地址: http://www.ecshop.com
 * ----------------------------------------------------------------------------
 * 这是一个免费开源的软件；这意味着您可以在不用于商业目的的前提下对程序代码
 * 进行修改、使用和再发布。
 * ============================================================================
 * $Author: hackfan $
 * $Date: 2007-10-15 13:58:43 +0800 (星期一, 15 十月 2007) $
 * $Id: myship.php 12919 2007-10-15 05:58:43Z hackfan $
 */

define('IN_ECS', true);

require_once('./includes/init.php');
require_once('./includes/lib_order.php');
include_once('includes/lib_transaction.php');

/* 载入语言文件 */
require_once(ROOT_PATH . 'languages/' .$_CFG['lang']. '/shopping_flow.php');
require_once(ROOT_PATH . 'languages/' .$_CFG['lang']. '/user.php');

/*------------------------------------------------------ */
//-- INPUT
/*------------------------------------------------------ */

if ($_SESSION['user_id'] > 0)
{
    $consignee_list = get_consignee_list($_SESSION['user_id']);

    $choose['country'] = isset($_POST['country']) ? $_POST['country'] : $consignee_list[0]['country'];
    $choose['province'] = isset($_POST['province']) ? $_POST['province'] : $consignee_list[0]['province'];
    $choose['city'] = isset($_POST['city']) ? $_POST['city'] : $consignee_list[0]['city'];
    $choose['district'] = isset($_POST['district']) ? $_POST['district'] : (isset($consignee_list[0]['district']) ? $consignee_list[0]['district'] : 0 );
}
else
{
    $choose['country'] = isset($_POST['country']) ? $_POST['country'] : $_CFG['shop_country'];
    $choose['province'] = isset($_POST['province']) ? $_POST['province'] : 2;
    $choose['city'] = isset($_POST['city']) ? $_POST['city'] : 35;
    $choose['district'] = isset($_POST['district']) ? $_POST['district'] : 417;
}

/*------------------------------------------------------ */
//-- PROCESSOR
/*------------------------------------------------------ */

assign_template();
assign_dynamic('myship');
$position = assign_ur_here(0, $_LANG['shopping_myship']);
$smarty->assign('page_title',       $position['title']);    // 页面标题
$smarty->assign('ur_here',          $position['ur_here']);  // 当前位置

$smarty->assign('helps',            get_shop_help());       // 网店帮助
$smarty->assign('lang',             $_LANG);

$smarty->assign('choose',             $choose);

$province_list[NULL] = get_regions(1, $choose['country']);
$city_list[NULL]     = get_regions(2, $choose['province']);
$district_list[NULL] = get_regions(3, $choose['city']);

$smarty->assign('province_list', $province_list);
$smarty->assign('city_list',     $city_list);
$smarty->assign('district_list', $district_list);

/* 取得国家列表、商店所在国家、商店所在国家的省列表 */
$smarty->assign('country_list',       get_regions());

/* 取得配送列表 */
$region            = array($choose['country'], $choose['province'], $choose['city'], $choose['district']);
$shipping_list     = available_shipping_list($region);

foreach ($shipping_list AS $key => $val)
{
    $fields = "";
    $shipping_cfg = unserialize_config($val['configure']);

    $sql = "SELECT a.shipping_name, a.shipping_code, a.support_cod, b.* ".
        "FROM " .$ecs->table('shipping'). " AS a, " .$ecs->table('shipping_area'). " AS b ".
        "WHERE b.shipping_id=a.shipping_id AND b.shipping_area_id='$val[shipping_id]'";
    $row = $db->getRow($sql);

    if($row['shipping_code'] != NULL)
    {
        include_once(ROOT_PATH.'includes/modules/shipping/'.$row['shipping_code'].'.php');
    }

    $fields = unserialize($row['configure']);

    if(is_array($fields))
    {
        $shipping_list[$key]['fee'] = "";
        foreach ($fields AS $k => $v)
        {
            $fields[$k]['label']  = $_LANG[$v['name']];
            $shipping_list[$key]['fee'] .= $fields[$k]['label'].' '.$fields[$k]['value'].' '.$_LANG['unit_yuan']." <br />\n";
        }
    }

    $shipping_list[$key]['insure_formated']     = strpos($val['insure'], '%') === false ? price_format($val['insure']) : $val['insure'];
}

$smarty->assign('shipping_list',   $shipping_list);
$smarty->display('myship.dwt');

